// ==UserScript==
// @name        SaveFrom.net link modifier
//
// @exclude     file://*
// @exclude     http://google.*/*
// @exclude     http://*.google.*/*
// @exclude     https://google.*/*
// @exclude     https://*.google.*/*
//
// @exclude     http://acidtests.org/*
// @exclude     http://*.acidtests.org/*
//
// @exclude     http://savefrom.net/*
// @exclude     http://*.savefrom.net/*
//
// @exclude     http://youtube.com/*
// @exclude     http://*.youtube.com/*
// @exclude     https://youtube.com/*
// @exclude     https://*.youtube.com/*
//
// @exclude     http://dailymotion.*/*
// @exclude     http://*.dailymotion.*/*
// @exclude     https://dailymotion.*/*
// @exclude     https://*.dailymotion.*/*
//
// @exclude     http://vimeo.com/*
// @exclude     http://*.vimeo.com/*
// @exclude     https://vimeo.com/*
// @exclude     https://*.vimeo.com/*
//
// @exclude     http://vk.com/*
// @exclude     http://*.vk.com/*
// @exclude     http://vkontakte.ru/*
// @exclude     http://*.vkontakte.ru/*
// @exclude     https://vk.com/*
// @exclude     https://*.vk.com/*
// @exclude     https://vkontakte.ru/*
// @exclude     https://*.vkontakte.ru/*
//
// @exclude     http://odnoklassniki.ru/*
// @exclude     http://*.odnoklassniki.ru/*
// @exclude     https://odnoklassniki.ru/*
// @exclude     https://*.odnoklassniki.ru/*
// @exclude     http://ok.ru/*
// @exclude     http://*.ok.ru/*
// @exclude     https://ok.ru/*
// @exclude     https://*.ok.ru/*
//
// @exclude     http://facebook.com/*
// @exclude     http://*.facebook.com/*
// @exclude     https://facebook.com/*
// @exclude     https://*.facebook.com/*
//
// @exclude     http://soundcloud.com/*
// @exclude     http://*.soundcloud.com/*
// @exclude     https://soundcloud.com/*
// @exclude     https://*.soundcloud.com/*
//
// @exclude     http://instagram.com/*
// @exclude     http://*.instagram.com/*
// @exclude     https://instagram.com/*
// @exclude     https://*.instagram.com/*
//
// @exclude     http://rutube.ru/*
// @exclude     http://*.rutube.ru/*
// @exclude     https://rutube.ru/*
// @exclude     https://*.rutube.ru/*
//
// ==/UserScript==

(typeof mono === 'undefined') && (mono = {loadModule: function() {this.loadModuleStack.push(arguments);},loadModuleStack: []});

mono.loadModule('sovetnik', function(moduleName, initData) {
  "use strict";
  var onScriptStart = function() {
    var limit = 30;
    var slice = [].slice;
    var interval = setInterval(function() {
      var id = null;

      var found = slice.call(document.querySelectorAll('body>style+div[id]>div[class]:not([id])>img[src]')).some(function(node) {
        if (!/^data:image\/png;/.test(node.src)) {
          return;
        }

        var parent = node.parentNode && node.parentNode.parentNode;
        if (!parent || !/^m/.test(parent.id)) {
          return;
        }

        var link = parent.querySelector('a[href]');
        if (!link || !/yandex/.test(link.href)) {
          return;
        }

        id = '#' + parent.id;
        return true;
      });

      limit--;
      if (limit < 0 || found) {
        clearInterval(interval);
      }

      found && addListener(id);
    }, 1000);

    var addListener = function(id) {
      var container = document.querySelector(id);
      if (!container) {
        return;
      }

      mono.sendMessage({action: 'trackEvent', category: 'sovetnik', event: 'show', label: 'bar', params: {tid: 'UA-67738130-3', noRewrite: true}});

      container.addEventListener('mousedown', function(e) {
        if (e.button !== 0) {
          return;
        }

        var link = e.target;
        while(link) {
          if (link.tagName === 'A') {
            break;
          }
          if (link.tagName === 'TR' && link.dataset.url) {
            break;
          }

          link = link.parentNode;
          if (link && link === container) {
            link = null;
          }
        }

        if (!link) {
          return;
        }

        var href = null;
        if (link.tagName === 'A') {
          href = link.getAttribute('href');
        }
        if (link.tagName === 'TR') {
          href = link.dataset.url;
        }
        var type = null;
        if (!href) {
          var prev = link.previousElementSibling;
          var next = link.nextElementSibling;
          if (!next || next.tagName !== 'A' || !next.querySelector('span')) {
            next = null;
          }
          if (next && next.nextElementSibling) {
            next = null;
          }
          var parent = link.parentNode;
          if (parent && parent.parentNode !== container) {
            parent = null;
          }
          if (parent && parent.childElementCount !== 2) {
            parent = null;
          }
          if (parent && !prev && next) {
            type = 'Show button';
          }
        } else
        if (/sovetnik\.market\.yandex/.test(href)) {
          var target = href.match(/[?&]target=([^&]+)/);
          target = target && target[1];

          type = target || 'unknown btn';
        }

        if (!type) {
          return;
        }

        mono.sendMessage({action: 'trackEvent', category: 'sovetnik', event: 'click', label: type, params: {tid: 'UA-67738130-3', ev: 2, noRewrite: true}});
        mono.sendMessage({action: 'trackEvent', category: 'sovetnik', event: 'click', label: type, params: {tid: 'UA-7055055-5', ev: 2, noRewrite: true}});
      });
    };
  };

  (function(){'use strict';

    var svt = {};
    (function () {
      var postMessageParser = {
        /**
         * return message if postMessage event was sent from our script
         * @param  {PostMessage} event
         * @return {Object}
         */
        getMessageFromEvent: function getMessageFromEvent(event) {
          if (!event.data) {
            return null;
          }

          var message = event.data;

          if (typeof message === 'string') {
            try {
              message = JSON.parse(message);
            } catch (ex) {
              return null;
            }
          }

          if (message && message.type === 'MBR_ENVIRONMENT' && !message.hasOwnProperty('response') && (message.clid || message.affId)) {
            return message;
          }

          return null;
        }
      };

      svt.postMessageParser = postMessageParser;
    })();
    (function () {
      var _listeners = {};

      function generateCookie() {
        return Math.round(Math.random() * 100500);
      }

      var messaging = {
        /**
         * Send message to other parts of extension
         * @param {Object} msg Any serializable javascript object
         * @param {Function} [responseCallback] Function to handle response
         */
        sendMessage: function sendMessage(msg, responseCallback) {
          var messageWrapper = {
            wrappedMessage: {
              stringifiedData: JSON.stringify(msg)
            }
          };

          if (responseCallback) {
            // we need to store response callback and mark it with random cookie value
            var cookie = generateCookie();
            _listeners[cookie] = responseCallback;
            messageWrapper.__cookie = cookie;
          }

          opera.extension.postMessage(messageWrapper);

          return this;
        }
      };

      opera.extension.addEventListener('message', function (event) {
        if (event.data && event.data.__cookie in _listeners) {
          var data = {};
          try {
            data = JSON.parse(event.data.wrappedMessage.stringifiedData);
          } catch (ex) {}

          _listeners[event.data.__cookie](data);

          delete _listeners[event.data.__cookie];
        }
      }, false);

      svt.messaging = messaging;
    })();
    (function () {
      var messaging = svt.messaging;

      function canUseSovetnik(url, referrer, successCallback) {
        messaging.sendMessage({
          type: 'canUseSovetnik',
          url: url,
          referrer: referrer
        }, function (res) {
          if (res) {
            successCallback();
          }
        });
      }

      svt.canUseSovetnik = canUseSovetnik;
    })();

    (function () {
      var messaging = svt.messaging;

      function getScriptContent(callback) {
        messaging.sendMessage({
          type: 'getScriptContent'
        }, callback);
      }

      function injectScript(doc, url, settings) {
        var script = doc.createElement('script');
        script.setAttribute('type', 'text/javascript');
        script.setAttribute('charset', 'UTF-8');

        if (/^http/.test(url)) {
          var params = [];
          params.push('mbr=true');
          params.push('settings=' + encodeURIComponent(JSON.stringify(settings)));
          params = params.join('&');

          url += '?' + params;

          script.setAttribute('src', url);

          doc.body.appendChild(script);
        } else {
          getScriptContent(function (scriptContent) {
            script.textContent = scriptContent;

            doc.body.appendChild(script);
          });
        }
      }

      svt.injectScript = injectScript;
    })();
    (function () {
      var messaging = svt.messaging;
      var injectScript = svt.injectScript;
      var canUseSovetnik = svt.canUseSovetnik;
      var postMessageParser = svt.postMessageParser;

      function initListeners() {
        var sovetnikInfo = null;
        var canUse = null;

        messaging.sendMessage({
          type: 'getSovetnikInfo'
        }, function (info) {
          sovetnikInfo = info;

          if (sovetnikInfo) {
            canUseSovetnik(document.URL, document.referrer, function () {
              injectScript(document, sovetnikInfo.url, sovetnikInfo.settings);
              onScriptStart();
            });
          }
        });

        window.addEventListener('message', function (event) {
          var message = postMessageParser.getMessageFromEvent(event, window.location.origin);

          if (message && sovetnikInfo && sovetnikInfo.settings) {
            if (sovetnikInfo.settings.clid) {
              if (sovetnikInfo.settings.clid != message.clid) {
                return;
              }
            } else if (sovetnikInfo.settings.affId != message.affId) {
              return;
            }
            //message from our script
            if (message.command) {
              switch (message.command) {
                case 'getDomainData':
                  messaging.sendMessage({
                    type: 'getDomainData',
                    domain: message.data.domain
                  }, function (domainData) {
                    message.response = domainData;
                    window.postMessage(JSON.stringify(message), event.origin);
                  });
                  break;
                case 'getSovetnikInfo':
                  message.response = sovetnikInfo.settings;
                  window.postMessage(JSON.stringify(message), event.origin);
                  break;
                case 'serverMessage':
                  messaging.sendMessage({
                    type: message.data.type,
                    domain: window.location.host
                  });
                  break;
                case 'showSettingsPage':
                  messaging.sendMessage({
                    type: 'showSettingsPage'
                  });
                  break;

              }
            }
          }
        }, false);
      }

      if (window && window.document && window.self === window.top) {
        if (window.document.readyState === 'complete' || window.document.readyState === 'interactive') {
          initListeners();
        } else {
          window.document.addEventListener('DOMContentLoaded', initListeners, false);
        }
      }
    })();

    (function () {
      var messaging = svt.messaging;

      if (window.self === window.top) {
        if (window.document.domain === 'sovetnik.yandex.ru' || window.document.domain === 'sovetnik.metabar.ru') {
          window.addEventListener('message', function (event) {
            if (event.data && event.data.type === 'MBR_ENVIRONMENT' && event.data.command === 'clid') messaging.sendMessage({
              type: 'saveClid',
              value: event.data.value
            });
          }, false);
        }
      }
    })();
  })();
}, function isActive(initData) {
  "use strict";
  if (mono.global.exAviaBar) {
    return false;
  }

  var preference = initData.getPreference;
  if (!preference.sovetnikEnabled) {
    return false;
  }

  var checkLanguage = function() {
    var langList = [
      'be', 'kk', 'ru', 'uk',
      'hy', 'ro', 'az', 'ka',
      'ky', 'uz', 'lv', 'lt',
      'et', 'tg', 'fi', 'tk'
    ];
    var countryList = [
      'by', 'kz', 'ru', 'ua',
      'am', 'md', 'az', 'ge',
      'kg', 'uz', 'lv', 'lt',
      'ee', 'tj', 'fi', 'tm'
    ];

    if (countryList.indexOf(preference.country) !== -1) {
      return true;
    }

    var lang = navigator.language.toLowerCase().substr(0, 2);
    if (langList.indexOf(lang) !== -1) {
      return true;
    }

    return false;
  };

  if(!checkLanguage()) {
    return false;
  }

  if (mono.global.ddblAdv) {
    return false;
  }
  mono.global.ddblAdv = true;

  return true;
}, function syncIsAvailable() {
  "use strict";
  if (mono.isIframe()) {
    return false;
  }

  var inWhiteList = function() {
    var list = [
      "adidas.ru",
      "agent.ru",
      "airberlin.com",
      "airfrance.ru",
      "alitalia.com",
      "all4.ru",
      "amazon.de",
      "anywayanyday.com",
      "avia.euroset.ru",
      "avia.travel.ru",
      "avia.tutu.ru",
      "aviacassa.ru",
      "avito.ru",
      "aws.amazon.com",
      "biletix.ru",
      "book.lufthansa.com",
      "booking.utair.ru",
      "bravoavia.ru",
      "britishairways.com",
      "canon.ru",
      "chrono24.com.ru",
      "citilink.ru",
      "domalina.ru",
      "dpreview.com",
      "engadget.com",
      "finnair.com",
      "haroldltd.ru",
      "hilti.ru",
      "iberia.com",
      "intershop.orenair.ru",
      "irmag.ru",
      "kaledos.ru",
      "kayak.ru",
      "klingel.ru",
      "klm.com",
      "kuvalda.ru",
      "lazurit.com",
      "letaem.ru",
      "light-flight.ru",
      "litres.ru",
      "lovemag.ru",
      "lufthansa.com",
      "magazinbt.ru",
      "malina.ru",
      "marketplace.asos.com",
      "mediamarkt.ru",
      "mir220v.ru",
      "momondo.ru",
      "mvideo.ru",
      "my.tiu.ru",
      "nabortu.ru",
      "nama.ru",
      "nespresso.com",
      "new.pososhok.ru",
      "nokia.com",
      "onetwotrip.com",
      "origin.com",
      "otto.de",
      "ozon.ru",
      "ozon.travel",
      "pass.rzd.ru",
      "pixel24.ru",
      "planetarium.ru",
      "planetashop.ru",
      "pososhok.ru",
      "reservation.aeroflot.ru",
      "rimeks.ru",
      "ru.puma.com",
      "s7.ru",
      "samsung.com",
      "sapato.ru",
      "shop.idj.by",
      "shop.kz",
      "shop.megafon.ru",
      "sindbad.ru",
      "skyscanner.ru",
      "softkey.ru",
      "sony.ru",
      "sotmarket.ru",
      "ssl.molotok.ru",
      "store.sony.ru",
      "svyaznoy.travel",
      "tinydeal.com",
      "transaero.ru",
      "transport.marshruty.ru",
      "travel.ulmart.ru",
      "trip.ru",
      "tripadvisor.ru",
      "tvoydom.ru",
      "utinet.ru",
      "vodopad.spb.ru",
      "webdush.ru",
      "xcom-shop.ru"
    ];

    return mono.matchHost(location.hostname, list);
  };

  var checkProtocol = function () {
    if (location.protocol === 'https:') {
      return inWhiteList();
    }
    return true;
  };

  if (!checkProtocol()) {
    return false;
  }

  var inBlackList = function() {
    var list = [
      "vk.com",
      "youtube.com",
      "odnoklassniki.ru",
      "ok.ru",
      "privet.ru",
      "facebook.com",
      "news.sportbox.ru",
      "play.google.com",
      "roem.ru",
      "linkedin.com",
      "ex.ua",
      "instagram.com",
      "rutube.ru",
      "e.mail.ru",
      "fotki.yandex.ru",
      "support.kaspersky.ru",
      "vimeo.com",
      "club.foto.ru",
      "garant.ru",
      "webmaster.yandex.ru",
      "support.kaspersky.ru",
      "fotki.yandex.ru",
      "mk.ru",
      "metrika.yandex.ru",
      "images.yandex.ru",
      "disk.yandex.ru",
      "maps.yandex.ru",
      "help.yandex.ru",
      "www.yaplakal.com",
      "www.facebook.com",
      "my.mail.ru"
    ];

    return mono.matchHost(location.hostname, list);
  };

  if(inBlackList()) {
    return false;
  }

  return true;
});