engine.sovetnikInit = function() {
  if (engine.sovetnikInit.fired) {
    return;
  }
  engine.sovetnikInit.fired = true;

  (function (SOVETNIK_SETTINGS, SCRIPT_URL) {/*
   CryptoJS v3.1.2
   code.google.com/p/crypto-js
   (c) 2009-2013 by Jeff Mott. All rights reserved.
   code.google.com/p/crypto-js/wiki/License
   */
    "use strict";

    var CryptoJS = CryptoJS || (function (s, p) {
        var m = {},
          l = m.lib = {},
          n = function n() {
          },
          r = l.Base = {
            extend: function extend(b) {
              n.prototype = this;
              var h = new n();
              b && h.mixIn(b);
              h.hasOwnProperty("init") || (h.init = function () {
                h.$super.init.apply(this, arguments);
              });
              h.init.prototype = h;
              h.$super = this;
              return h;
            }, create: function create() {
              var b = this.extend();
              b.init.apply(b, arguments);
              return b;
            }, init: function init() {
            }, mixIn: function mixIn(b) {
              for (var h in b) b.hasOwnProperty(h) && (this[h] = b[h]);
              b.hasOwnProperty("toString") && (this.toString = b.toString);
            }, clone: function clone() {
              return this.init.prototype.extend(this);
            }
          },
          q = l.WordArray = r.extend({
            init: function init(b, h) {
              b = this.words = b || [];
              this.sigBytes = h != p ? h : 4 * b.length;
            }, toString: function toString(b) {
              return (b || t).stringify(this);
            }, concat: function concat(b) {
              var h = this.words,
                a = b.words,
                j = this.sigBytes;
              b = b.sigBytes;
              this.clamp();
              if (j % 4) for (var g = 0; g < b; g++) h[j + g >>> 2] |= (a[g >>> 2] >>> 24 - 8 * (g % 4) & 255) << 24 - 8 * ((j + g) % 4); else if (65535 < a.length) for (g = 0; g < b; g += 4) h[j + g >>> 2] = a[g >>> 2]; else h.push.apply(h, a);
              this.sigBytes += b;
              return this;
            }, clamp: function clamp() {
              var b = this.words,
                h = this.sigBytes;
              b[h >>> 2] &= 4294967295 << 32 - 8 * (h % 4);
              b.length = s.ceil(h / 4);
            }, clone: function clone() {
              var b = r.clone.call(this);
              b.words = this.words.slice(0);
              return b;
            }, random: function random(b) {
              for (var h = [], a = 0; a < b; a += 4) h.push(4294967296 * s.random() | 0);
              return new q.init(h, b);
            }
          }),
          v = m.enc = {},
          t = v.Hex = {
            stringify: function stringify(b) {
              var a = b.words;
              b = b.sigBytes;
              for (var g = [], j = 0; j < b; j++) {
                var k = a[j >>> 2] >>> 24 - 8 * (j % 4) & 255;
                g.push((k >>> 4).toString(16));
                g.push((k & 15).toString(16));
              }
              return g.join("");
            }, parse: function parse(b) {
              for (var a = b.length, g = [], j = 0; j < a; j += 2) g[j >>> 3] |= parseInt(b.substr(j, 2), 16) << 24 - 4 * (j % 8);
              return new q.init(g, a / 2);
            }
          },
          a = v.Latin1 = {
            stringify: function stringify(b) {
              var a = b.words;
              b = b.sigBytes;
              for (var g = [], j = 0; j < b; j++) g.push(String.fromCharCode(a[j >>> 2] >>> 24 - 8 * (j % 4) & 255));
              return g.join("");
            }, parse: function parse(b) {
              for (var a = b.length, g = [], j = 0; j < a; j++) g[j >>> 2] |= (b.charCodeAt(j) & 255) << 24 - 8 * (j % 4);
              return new q.init(g, a);
            }
          },
          u = v.Utf8 = {
            stringify: function stringify(b) {
              try {
                return decodeURIComponent(escape(a.stringify(b)));
              } catch (g) {
                throw Error("Malformed UTF-8 data");
              }
            }, parse: function parse(b) {
              return a.parse(unescape(encodeURIComponent(b)));
            }
          },
          g = l.BufferedBlockAlgorithm = r.extend({
            reset: function reset() {
              this._data = new q.init();
              this._nDataBytes = 0;
            }, _append: function _append(b) {
              "string" == typeof b && (b = u.parse(b));
              this._data.concat(b);
              this._nDataBytes += b.sigBytes;
            }, _process: function _process(b) {
              var a = this._data,
                g = a.words,
                j = a.sigBytes,
                k = this.blockSize,
                m = j / (4 * k),
                m = b ? s.ceil(m) : s.max((m | 0) - this._minBufferSize, 0);
              b = m * k;
              j = s.min(4 * b, j);
              if (b) {
                for (var l = 0; l < b; l += k) this._doProcessBlock(g, l);
                l = g.splice(0, b);
                a.sigBytes -= j;
              }
              return new q.init(l, j);
            }, clone: function clone() {
              var b = r.clone.call(this);
              b._data = this._data.clone();
              return b;
            }, _minBufferSize: 0
          });
        l.Hasher = g.extend({
          cfg: r.extend(), init: function init(b) {
            this.cfg = this.cfg.extend(b);
            this.reset();
          }, reset: function reset() {
            g.reset.call(this);
            this._doReset();
          }, update: function update(b) {
            this._append(b);
            this._process();
            return this;
          }, finalize: function finalize(b) {
            b && this._append(b);
            return this._doFinalize();
          }, blockSize: 16, _createHelper: function _createHelper(b) {
            return function (a, g) {
              return new b.init(g).finalize(a);
            };
          }, _createHmacHelper: function _createHmacHelper(b) {
            return function (a, g) {
              return new k.HMAC.init(b, g).finalize(a);
            };
          }
        });
        var k = m.algo = {};
        return m;
      })(Math);
    (function (s) {
      function p(a, k, b, h, l, j, m) {
        a = a + (k & b | ~k & h) + l + m;
        return (a << j | a >>> 32 - j) + k;
      }

      function m(a, k, b, h, l, j, m) {
        a = a + (k & h | b & ~h) + l + m;
        return (a << j | a >>> 32 - j) + k;
      }

      function l(a, k, b, h, l, j, m) {
        a = a + (k ^ b ^ h) + l + m;
        return (a << j | a >>> 32 - j) + k;
      }

      function n(a, k, b, h, l, j, m) {
        a = a + (b ^ (k | ~h)) + l + m;
        return (a << j | a >>> 32 - j) + k;
      }

      for (var r = CryptoJS, q = r.lib, v = q.WordArray, t = q.Hasher, q = r.algo, a = [], u = 0; 64 > u; u++) a[u] = 4294967296 * s.abs(s.sin(u + 1)) | 0;
      q = q.MD5 = t.extend({
        _doReset: function _doReset() {
          this._hash = new v.init([1732584193, 4023233417, 2562383102, 271733878]);
        },
        _doProcessBlock: function _doProcessBlock(g, k) {
          for (var b = 0; 16 > b; b++) {
            var h = k + b,
              w = g[h];
            g[h] = (w << 8 | w >>> 24) & 16711935 | (w << 24 | w >>> 8) & 4278255360;
          }
          var b = this._hash.words,
            h = g[k + 0],
            w = g[k + 1],
            j = g[k + 2],
            q = g[k + 3],
            r = g[k + 4],
            s = g[k + 5],
            t = g[k + 6],
            u = g[k + 7],
            v = g[k + 8],
            x = g[k + 9],
            y = g[k + 10],
            z = g[k + 11],
            A = g[k + 12],
            B = g[k + 13],
            C = g[k + 14],
            D = g[k + 15],
            c = b[0],
            d = b[1],
            e = b[2],
            f = b[3],
            c = p(c, d, e, f, h, 7, a[0]),
            f = p(f, c, d, e, w, 12, a[1]),
            e = p(e, f, c, d, j, 17, a[2]),
            d = p(d, e, f, c, q, 22, a[3]),
            c = p(c, d, e, f, r, 7, a[4]),
            f = p(f, c, d, e, s, 12, a[5]),
            e = p(e, f, c, d, t, 17, a[6]),
            d = p(d, e, f, c, u, 22, a[7]),
            c = p(c, d, e, f, v, 7, a[8]),
            f = p(f, c, d, e, x, 12, a[9]),
            e = p(e, f, c, d, y, 17, a[10]),
            d = p(d, e, f, c, z, 22, a[11]),
            c = p(c, d, e, f, A, 7, a[12]),
            f = p(f, c, d, e, B, 12, a[13]),
            e = p(e, f, c, d, C, 17, a[14]),
            d = p(d, e, f, c, D, 22, a[15]),
            c = m(c, d, e, f, w, 5, a[16]),
            f = m(f, c, d, e, t, 9, a[17]),
            e = m(e, f, c, d, z, 14, a[18]),
            d = m(d, e, f, c, h, 20, a[19]),
            c = m(c, d, e, f, s, 5, a[20]),
            f = m(f, c, d, e, y, 9, a[21]),
            e = m(e, f, c, d, D, 14, a[22]),
            d = m(d, e, f, c, r, 20, a[23]),
            c = m(c, d, e, f, x, 5, a[24]),
            f = m(f, c, d, e, C, 9, a[25]),
            e = m(e, f, c, d, q, 14, a[26]),
            d = m(d, e, f, c, v, 20, a[27]),
            c = m(c, d, e, f, B, 5, a[28]),
            f = m(f, c, d, e, j, 9, a[29]),
            e = m(e, f, c, d, u, 14, a[30]),
            d = m(d, e, f, c, A, 20, a[31]),
            c = l(c, d, e, f, s, 4, a[32]),
            f = l(f, c, d, e, v, 11, a[33]),
            e = l(e, f, c, d, z, 16, a[34]),
            d = l(d, e, f, c, C, 23, a[35]),
            c = l(c, d, e, f, w, 4, a[36]),
            f = l(f, c, d, e, r, 11, a[37]),
            e = l(e, f, c, d, u, 16, a[38]),
            d = l(d, e, f, c, y, 23, a[39]),
            c = l(c, d, e, f, B, 4, a[40]),
            f = l(f, c, d, e, h, 11, a[41]),
            e = l(e, f, c, d, q, 16, a[42]),
            d = l(d, e, f, c, t, 23, a[43]),
            c = l(c, d, e, f, x, 4, a[44]),
            f = l(f, c, d, e, A, 11, a[45]),
            e = l(e, f, c, d, D, 16, a[46]),
            d = l(d, e, f, c, j, 23, a[47]),
            c = n(c, d, e, f, h, 6, a[48]),
            f = n(f, c, d, e, u, 10, a[49]),
            e = n(e, f, c, d, C, 15, a[50]),
            d = n(d, e, f, c, s, 21, a[51]),
            c = n(c, d, e, f, A, 6, a[52]),
            f = n(f, c, d, e, q, 10, a[53]),
            e = n(e, f, c, d, y, 15, a[54]),
            d = n(d, e, f, c, w, 21, a[55]),
            c = n(c, d, e, f, v, 6, a[56]),
            f = n(f, c, d, e, D, 10, a[57]),
            e = n(e, f, c, d, t, 15, a[58]),
            d = n(d, e, f, c, B, 21, a[59]),
            c = n(c, d, e, f, r, 6, a[60]),
            f = n(f, c, d, e, z, 10, a[61]),
            e = n(e, f, c, d, j, 15, a[62]),
            d = n(d, e, f, c, x, 21, a[63]);
          b[0] = b[0] + c | 0;
          b[1] = b[1] + d | 0;
          b[2] = b[2] + e | 0;
          b[3] = b[3] + f | 0;
        }, _doFinalize: function _doFinalize() {
          var a = this._data,
            k = a.words,
            b = 8 * this._nDataBytes,
            h = 8 * a.sigBytes;
          k[h >>> 5] |= 128 << 24 - h % 32;
          var l = s.floor(b / 4294967296);
          k[(h + 64 >>> 9 << 4) + 15] = (l << 8 | l >>> 24) & 16711935 | (l << 24 | l >>> 8) & 4278255360;
          k[(h + 64 >>> 9 << 4) + 14] = (b << 8 | b >>> 24) & 16711935 | (b << 24 | b >>> 8) & 4278255360;
          a.sigBytes = 4 * (k.length + 1);
          this._process();
          a = this._hash;
          k = a.words;
          for (b = 0; 4 > b; b++) h = k[b], k[b] = (h << 8 | h >>> 24) & 16711935 | (h << 24 | h >>> 8) & 4278255360;
          return a;
        }, clone: function clone() {
          var a = t.clone.call(this);
          a._hash = this._hash.clone();
          return a;
        }
      });
      r.MD5 = t._createHelper(q);
      r.HmacMD5 = t._createHmacHelper(q);
    })(Math);

    var svt = {};
    (function () {
      svt.XMLHttpRequest = XMLHttpRequest;
    })();
    (function () {
      var config = {
        _current: {
          apiHost: "%SOVETNIK_API_HOST%",
          staticHost: "%SOVETNIK_STORAGE_HOST%"
        },

        _production: {
          apiHost: "https://sovetnik.market.yandex.ru",
          staticHost: "https://static.sovetnik.yandex.net"
        },

        /**
         * return true if host is not a template-string
         * @param host
         * @returns {Boolean}
         * @private
         */
        _isPatched: function _isPatched(host) {
          return !/^%[^%]+%$/.test(host);
        },

        /**
         * get host value by name. If host has been patched, we have current host. Otherwise - host from production
         * @param {String} hostName apiHost, storageHost or settingsHost
         * @returns {String}
         * @private
         */
        _getHost: function _getHost(hostName) {
          if (this._current[hostName] && this._isPatched(this._current[hostName])) {
            return this._current[hostName];
          }
          return this._production[hostName];
        },

        getApiHost: function getApiHost() {
          return this._getHost("apiHost");
        },

        getStaticHost: function getStaticHost() {
          return this._getHost("staticHost");
        }
      };

      svt.config = config;
    })();
    (function () {
      var apiHost = svt.config.getApiHost();
      var staticHost = svt.config.getStaticHost();

      var XMLHttpRequest = svt.XMLHttpRequest;

      var backend = {
        _checkUrl: apiHost + "/settings/check",
        _ysUrl: apiHost + "/sovetnik",
        _domainsUrl: staticHost + "/static/script-data/domains.json",

        _sendRequest: function _sendRequest(url, callback) {
          var xhr = new XMLHttpRequest();
          xhr.withCredentials = true;

          xhr.open("GET", url, true);

          xhr.onreadystatechange = function () {
            if (xhr.readyState === 4 && xhr.status === 200) {
              callback(xhr.responseText);
            }
          };

          xhr.send(null);
        },

        _checkFromBackend: function _checkFromBackend(url, params, callback) {
          var paramsArr = [];
          for (var i in params) {
            paramsArr.push(i + "=" + encodeURIComponent(params[i]));
          }
          if (paramsArr.length) {
            url = url + "?" + paramsArr.join("&");
          }

          this._sendRequest(url, function (responseText) {
            if (responseText) {
              var response = JSON.parse(responseText);
              if (response.hasOwnProperty("status")) {
                callback(response.status);
              }
            }
          });
        },

        loadDomainsInfo: function loadDomainsInfo(callback) {
          var url = this._domainsUrl + "?hash=" + Date.now();
          this._sendRequest(url, function (responseText) {
            if (responseText) {
              try {
                var domainsInfo = JSON.parse(responseText);
                callback(domainsInfo);
              } catch (ex) {
              }
            }
          });
        },

        isDomainDisabled: function isDomainDisabled(domain, callback) {
          this._checkFromBackend(this._checkUrl, {domain: domain}, callback);
        },

        isOfferRejected: function isOfferRejected(callback) {
          this._checkFromBackend(this._checkUrl, {offer: true}, callback);
        },

        isSovetnikRemoved: function isSovetnikRemoved(callback) {
          this._checkFromBackend(this._checkUrl, {removed: true}, callback);
        },

        isSecondScript: function isSecondScript(clid, affId, callback) {
          this._checkFromBackend(this._checkUrl, {
            affId: affId,
            clid: clid
          }, callback);
        },

        setStartedInfo: function setStartedInfo(callback) {
          var xhr = new XMLHttpRequest();
          xhr.withCredentials = true;

          xhr.open("POST", this._ysUrl, true);
          xhr.setRequestHeader("Content-Type", "application/json;charset=UTF-8");

          xhr.onreadystatechange = function () {
            if (xhr.readyState === 4 && xhr.status === 200) {
              callback && callback(xhr.responseText);
            }
          };

          xhr.send(JSON.stringify({version: 1}));
        }

      };

      svt.backend = backend;
    })();
    (function () {
      var backend = svt.backend;

      backend.setStartedInfo();
    })();
    (function () {
      var messaging = {
        onMessage: function onMessage(listener) {
          opera.extension.addEventListener("message", function (event) {
            if (!event.data.wrappedMessage) {
              return;
            }

            var cookie = event.data.__cookie;

            setTimeout(listener(JSON.parse(event.data.wrappedMessage.stringifiedData), function (msg) {
              if (cookie) {
                setTimeout(function () {
                  try {
                    event.source.postMessage({
                      __cookie: cookie,
                      wrappedMessage: {
                        stringifiedData: JSON.stringify(msg)
                      }
                    });
                  } catch (ex) {
                  }
                }, 0);
              }
            }), 0);
          });

          return this;
        }
      };

      svt.messaging = messaging;
    })();

    (function () {
      var prefix = SOVETNIK_SETTINGS.sovetnikExtension ? "" : "sovetnik";

      var storage = {
        get: function get(name) {
          name = prefix + name;
          return localStorage.getItem(name);
        },

        set: function set(name, value) {
          name = prefix + name;
          localStorage.setItem(name, value);
        }
      };

      svt.storage = storage;
    })();
    (function () {
      var storage = svt.storage;

      var cacheInterval = 7 * 24 * 60 * 60 * 1000;
      var domains = storage.get("disabledDomains");
      domains = domains ? JSON.parse(domains) : {};

      //invalidate cache
      var currentTime = Date.now();
      for (var domain in domains) {
        if (domains[domain] && currentTime - domains[domain] > cacheInterval) {
          domains[domain] = 0;
        }
      }

      var disabledDomains = {
        isDomainDisabled: function isDomainDisabled(domain) {
          return !!domains[domain];
        },

        disableDomain: function disableDomain(domain) {
          domains[domain] = Date.now();
          storage.set("disabledDomains", JSON.stringify(domains));
        }
      };

      svt.disabledDomains = disabledDomains;
    })();
    (function () {
      svt.settingsPage = {
        _customFunc: null,

        addCustomFunc: function addCustomFunc(func) {
          this._customFunc = func;
        },

        open: function open() {
          this._customFunc && this._customFunc();
        }
      };
    })();

    (function () {
      var storage = svt.storage;
      var settingsPage = svt.settingsPage;

      var SECOND_SCRIPT_UPDATE_INTERVAL = 24 * 60 * 60 * 1000;

      var isOfferRejected = storage.get("offerRejected");
      var isSovetnikRemoved = storage.get("sovetnikRemoved");
      if (isSovetnikRemoved) {
        isSovetnikRemoved = JSON.parse(isSovetnikRemoved);
      }
      var secondScriptTrackDate = storage.get("secondScript");
      secondScriptTrackDate = secondScriptTrackDate ? parseInt(secondScriptTrackDate, 10) : 0;
      var isSecondScript = Date.now() - secondScriptTrackDate < SECOND_SCRIPT_UPDATE_INTERVAL;

      var settings = SOVETNIK_SETTINGS;
      var userSettings = storage.get("userSettings");
      if (!userSettings) {
        userSettings = {};
      } else {
        userSettings = JSON.parse(userSettings);
      }
      for (var i in userSettings) {
        if (userSettings.hasOwnProperty(i)) {
          settings[i] = userSettings[i];
        }
      }

      settings.extensionStorage = true;

      if (storage.get("sovetnik.yandex.statistics.clid.21")) {
        var clid = storage.get("sovetnik.yandex.statistics.clid.21");
        if (typeof clid === "string") {
          clid = clid.replace(/[^\d\-]/g, "");
        }
        settings.clid = parseInt(clid, 10);
      }

      var onUserSettingsListeners = [];

      var sovetnikInfo = {
        isOfferRejected: isOfferRejected,
        isSecondScript: isSecondScript,
        isSovetnikRemoved: isSovetnikRemoved,

        settings: settings,
        url: SCRIPT_URL,

        setCustomSettingsPage: function setCustomSettingsPage(func) {
          settings.customSettingsPage = true;
          settingsPage.addCustomFunc(func);
        },

        setOfferRejected: function setOfferRejected() {
          this.isOfferRejected = true;
          storage.set("offerRejected", "true");
        },

        setSovetnikRemovedState: function setSovetnikRemovedState(state) {
          this.isSovetnikRemoved = state;
          storage.set("sovetnikRemoved", JSON.stringify(state));

          engine.actionList.updateOption({key: 'sovetnikEnabled', value: state ? 0 : 1});
        },

        setSecondScript: function setSecondScript() {
          this.isSecondScript = true;
          storage.set("secondScript", JSON.stringify(Date.now()));
        },
        setUserSetting: function setUserSetting(name, value) {
          settings[name] = value;
          userSettings[name] = value;
          storage.set("userSettings", JSON.stringify(userSettings));

          onUserSettingsListeners.forEach(function (listener) {
            try {
              listener();
            } catch (ex) {
            }
          });
        },

        onUserSettingChanged: function onUserSettingChanged(listener) {
          onUserSettingsListeners.push(listener);
        },

        setClid: function setClid(clid) {
          this.settings.clid = clid;
          storage.set("sovetnik.yandex.statistics.clid.21", clid);

          onUserSettingsListeners.forEach(function (listener) {
            try {
              listener();
            } catch (ex) {
            }
          });
        },

        isSovetnikExtension: function isSovetnikExtension() {
          return !!settings.sovetnikExtension;
        }
      };

      svt.sovetnikInfo = sovetnikInfo;
    })();
    (function () {
      var messaging = svt.messaging;
      var sovetnikInfo = svt.sovetnikInfo;

      var scriptContent;

      function getScriptContent(callback) {
        var path = sovetnikInfo.url;

        if (!/^http/.test(path)) {
          //local path
          var fileObj = opera.extension.getFile(path);

          var fr = new FileReader();
          fr.onload = function () {
            scriptContent = "(function() {" + "var settingsJSON = " + JSON.stringify(sovetnikInfo.settings) + ";" + fr.result + "})()";
            callback && callback();
          };
          fr.readAsText(fileObj);
        }
      }

      getScriptContent(function () {
        messaging.onMessage(function (message, callback) {
          if (message.type === "getScriptContent") {
            callback && callback(scriptContent);
          }
        });
      });

      sovetnikInfo.onUserSettingChanged(getScriptContent);
    })();
    (function () {
      var storage = svt.storage;
      var backend = svt.backend;
      var disabledDomains = svt.disabledDomains;
      var sovetnikInfo = svt.sovetnikInfo;

      var SITE_INFO_UPDATE_INTERVAL = 24 * 60 * 60 * 1000;
      var domainRE = /(https?):\/\/([^\/]+)/;
      var yandexRE = /ya(ndex)?\./;
      var marketRE = /(market\.yandex)|(market\-click2\.yandex)/;
      var sovetnikRE = /^https?:\/\/sovetnik\./;
      var simpleMarketRE = /market/i;

      var siteInfo = {
        _domainsInfo: null,
        _customCheckFunction: null,

        _init: function _init() {
          var domains = storage.get("domains") || "null";
          if (domains) {
            this._domainsInfo = JSON.parse(domains);
          }

          var lastUpdateTime = parseInt(storage.get("lastUpdateTime"), 10) || 0;
          if (Date.now() - lastUpdateTime > SITE_INFO_UPDATE_INTERVAL) {
            this._loadData();
          }
        },

        _loadData: function _loadData() {
          backend.loadDomainsInfo((function (domainsInfo) {
            if (domainsInfo) {
              this._domainsInfo = domainsInfo;
              storage.set("domains", JSON.stringify(domainsInfo));
              storage.set("lastUpdateTime", Date.now());
            }
          }).bind(this));
        },

        getDomainData: function getDomainData(domain) {
          var currentHash;
          while (this._domainsInfo && domain && domain.indexOf(".") !== -1) {
            var currentHash = CryptoJS.MD5(domain).toString();

            if (this._domainsInfo[currentHash]) {
              return this._domainsInfo[currentHash];
            }

            domain = domain.replace(/^[^\.]+\./, "");
          }

          return null;
        },

        canUseSovetnik: function canUseSovetnik(url, referrerUrl) {
          if (sovetnikInfo.isSecondScript || sovetnikInfo.isOfferRejected || sovetnikInfo.isSovetnikRemoved) {
            return false;
          }

          if (this._customCheckFunction && !this._customCheckFunction(url, referrerUrl)) {
            return false;
          }

          if (sovetnikRE.test(url)) {
            return true;
          }

          if (domainRE.test(url)) {
            var protocol = RegExp.$1;
            var domain = RegExp.$2;
            var referrerDomain;
            if (domainRE.test(referrerUrl)) {
              referrerDomain = RegExp.$2;
            }

            var domainInfo = this.getDomainData(domain);
            var referrerInfo = this.getDomainData(referrerDomain);

            if (disabledDomains.isDomainDisabled(domain)) {
              return false;
            }

            if (protocol === "https" && !domainInfo) {
              return false;
            }

            if (domainInfo && domainInfo.rules && domainInfo.rules.length) {
              if (domainInfo.rules.indexOf("blacklisted") !== -1) {
                return false;
              }
              if (domainInfo.rules.indexOf("yandex-web-partner") !== -1) {
                return false;
              }
            }

            if (referrerInfo && referrerInfo.rules && referrerInfo.rules.length) {
              if (referrerInfo.rules.indexOf("blacklisted-by-referrer") !== -1) {
                return false;
              }
            }

            if (yandexRE.test(domain)) {
              return false;
            }
          } else {
            return false;
          }
          return true;
        },

        setCustomCheckFunction: function setCustomCheckFunction(func) {
          this._customCheckFunction = func;
        }
      };

      siteInfo._init();

      svt.siteInfo = siteInfo;
    })();
    (function () {
      "use strict";

      var tabs = {
        create: function create(url) {
          opera.extension.tabs.create({
            url: url,
            focused: true
          });
        }
      };

      svt.tabs = tabs;
    })();
    (function () {
      var messaging = svt.messaging;
      var storage = svt.storage;
      var sovetnikInfo = svt.sovetnikInfo;

      messaging.onMessage(function (message) {
        if (message.type == "saveClid" && !storage.get("clidSaved")) {
          sovetnikInfo.setClid(parseInt(message.value, 10));
          storage.set("clidSaved", true);
        }
      });
    })();
    (function () {
      var messaging = svt.messaging;
      var siteInfo = svt.siteInfo;
      var sovetnikInfo = svt.sovetnikInfo;
      var backend = svt.backend;
      var storage = svt.storage;
      var disabledDomains = svt.disabledDomains;
      var settingsPage = svt.settingsPage;

      messaging.onMessage(function (message, callback) {
        if (message.type) {
          switch (message.type) {
            case "getDomainData":
              callback && callback(siteInfo.getDomainData(message.domain));
              break;
            case "getSovetnikInfo":
              callback && callback(sovetnikInfo);
              break;
            case "canUseSovetnik":
              callback && callback(siteInfo.canUseSovetnik(message.url, message.referrer));
              break;
            case "secondScript":
              backend.isSecondScript(sovetnikInfo.settings.clid, sovetnikInfo.settings.affId, function (isSecondScript) {
                if (isSecondScript) {
                  sovetnikInfo.setSecondScript();
                }
              });
              break;
            case "sovetnikRemoved":
              backend.isSovetnikRemoved(function (isRemoved) {
                if (isRemoved) {
                  sovetnikInfo.setSovetnikRemovedState(true);
                }
              });
              break;
            case "offerRejected":
              backend.isOfferRejected(function (isOfferRejected) {
                if (isOfferRejected) {
                  sovetnikInfo.setOfferRejected();
                }
              });
              break;
            case "domainDisabled":
              backend.isDomainDisabled(message.domain, function (domainDisabled) {
                if (domainDisabled) {
                  disabledDomains.disableDomain(message.domain);
                }
              });
              break;
            case "showSettingsPage":
              settingsPage.open();
              break;
          }
        }
      });
    })();

    (function () {
      var siteInfo = svt.siteInfo;
      var sovetnikInfo = svt.sovetnikInfo;

      var API = {
        /**
         * set custom check function to disable Sovetnik according to current URL and referrer URL
         * @param {Function(currentUrl, referrerUrl)} handler
         */
        setCheckFunction: function setCheckFunction(handler) {
          siteInfo.setCustomCheckFunction(handler);
        },

        setOpenSettingsFunction: function setOpenSettingsFunction(handler) {
          sovetnikInfo.setCustomSettingsPage(handler);
        },
        /**
         * enable or disable shops' popup onHover showing
         * @param {Boolean} isEnabled
         */
        setAutoShowPopup: function setAutoShowPopup(isEnabled) {
          sovetnikInfo.setUserSetting("autoShowShopList", isEnabled);
        },

        /**
         * set current user's city
         * @param {Number} cityId
         */
        setActiveCity: function setActiveCity(cityId) {
          sovetnikInfo.setUserSetting("activeCity", {id: cityId});
        },

        /**
         * set current user's country
         * @param {Number} countryId
         */
        setActiveCountry: function setActiveCountry(countryId) {
          sovetnikInfo.setUserSetting("activeCountry", {id: countryId});
        },

        setAutoDetectRegion: function setAutoDetectRegion() {
          sovetnikInfo.setUserSetting("activeCity", null);
          sovetnikInfo.setUserSetting("activeCountry", null);
        },

        /**
         * set true if user wants to receive offers from other regions or false if he doesn't
         * @param {Boolean} otherRegionsEnabled
         */
        setOtherRegions: function setOtherRegions(otherRegionsEnabled) {
          sovetnikInfo.setUserSetting("otherRegions", otherRegionsEnabled);
        },

        /**
         * set sovetnik removed state
         * @param {Boolean} state
         */
        setRemovedState: function setRemovedState(state) {
          sovetnikInfo.setSovetnikRemovedState(state);
        }
      };

      svt.API = API;
    })();
    (function () {
      window.sovetnik = svt.API;
    })();
  })({
    "affId": 1020,
    "clid": 2210496,
    "applicationName": "SaveFrom",
    "offerEnabled": true
  }, 'sovetnik.opera.min.js');
};